import javax.microedition.lcdui.*;
import java.util.*;

public class M2ng extends Canvas implements CommandListener{
	static final Color TAUST=new Color(210,245,210);
	static final Color RADA=new Color(20,200,20);
	static final Color MUNA=new Color(150,150,150);
	static final Color KORV=new Color(50,20,80);
	static final Color MAA=new Color(60,150,150);
	static final Color JOONED=new Color(0,0,0);

	static final int munaSuurus=16;
	static final int xySuhe=2;
	static final int kiirusOhus=10;
	static final int punktidYheMunaEest=10;

	int korgus, laius;	 // ekraani omad
	int pikkus;			 // korvi pikkus (hetkel ekraani laius/4)
        int x,y;		     // korvi koordinaadid!
	boolean ax,ay;       // korvi neli vimalikku asendit;

	int elud;
	int punktid;

	Timer t;
	Vector m=new Vector();
	Random rnd=new Random();
	Command exit=new Command("Vlju", Command.EXIT,1);

	public M2ng(){
		addCommand(exit);
		setCommandListener(this);
	}

	public void commandAction(Command command, Displayable displayable) {
		if (command==exit){
			Munapyydja.kuvaEkraan(new Menyy());
		}	
	}


	protected void paint(Graphics g){
		puhastaTaust(g);
		joonistaMaa(g);
		joonistaRajad(g);
		joonistaMunad(g);
		joonistaKorv(g);
		joonistaSkoor(g);
	}

	void joonistaSkoor(Graphics g){
		JOONED.colorize(g);
		for(int i=1; i<elud; i++){
	   		g.fillArc(i*8, 8, 6,6,0,360);
		}
		g.drawString("Punktid: "+String.valueOf(punktid), laius, 0, Graphics.TOP|Graphics.RIGHT);
	}

	void joonistaKorv(Graphics g){
		if (ax){
			x=laius-pikkus-pikkus/2-munaSuurus;
		} else {
			x=pikkus-pikkus/2+munaSuurus;
		}
		if (ay){
			y=korgus/2-5;
		} else{
			y=korgus/2+(korgus/2-korgus/5)-5;
		}

		KORV.colorize(g);
		g.fillRect(x, y, pikkus, 4);
		g.fillRoundRect(x, y, pikkus, munaSuurus, 5,5);
	}

	void puhastaTaust(Graphics g){
		TAUST.colorize(g);
    	g.fillRect(0, 0, getWidth(), getHeight());
	}	
	
	void joonistaRajad(Graphics g){
		RADA.colorize(g);

		g.fillTriangle(0,korgus/5,pikkus,pikkus/xySuhe+korgus/5,0,korgus/5+15);
		g.fillTriangle(laius,korgus/5,laius-pikkus,pikkus/xySuhe+korgus/5, laius, korgus/5+15);

		g.fillTriangle(0,korgus/2,pikkus,pikkus/xySuhe+korgus/2, 0, korgus/2+15);
		g.fillTriangle(laius,korgus/2,laius-pikkus,pikkus/xySuhe+korgus/2, laius, korgus/2+15);

		JOONED.colorize(g);
		g.drawLine(pikkus,pikkus/xySuhe+korgus/5,0,korgus/5+15);
		g.drawLine(laius-pikkus,pikkus/xySuhe+korgus/5, laius, korgus/5+15);
		g.drawLine(pikkus,pikkus/xySuhe+korgus/2, 0, korgus/2+15);
		g.drawLine(laius-pikkus,pikkus/xySuhe+korgus/2, laius, korgus/2+15);
		g.drawLine(0,korgus/5,pikkus,pikkus/xySuhe+korgus/5);
		g.drawLine(laius,korgus/5,laius-pikkus,pikkus/xySuhe+korgus/5);
		g.drawLine(0,korgus/2,pikkus,pikkus/xySuhe+korgus/2);
		g.drawLine(laius,korgus/2,laius-pikkus,pikkus/xySuhe+korgus/2);
	}

	void joonistaMunad(Graphics g){

		Muna tmp;
		for(int i=0; i<m.size(); i++){
		   tmp=(Muna)m.elementAt(i);
		   MUNA.colorize(g);
		   g.fillArc(tmp.x, tmp.y, munaSuurus,munaSuurus,0,360);
		   JOONED.colorize(g);
		   g.drawArc(tmp.x, tmp.y, munaSuurus,munaSuurus,0,360);
		}
	}

	void joonistaMaa(Graphics g){
		 MAA.colorize(g);
		 g.fillRect(0,korgus-korgus/10, laius, korgus-korgus/10);
		 JOONED.colorize(g);
		 g.drawRect(0,korgus-korgus/10, laius, korgus-korgus/10);
	}

	protected void keyPressed(int kood){
		if (getGameAction(kood)==LEFT){
			ax=false;
		}
		if (getGameAction(kood)==RIGHT){
			ax=true;
		}
		if (getGameAction(kood)==UP){
			ay=true;
		}
		if (getGameAction(kood)==DOWN){
			ay=false;
		}		
	}

	public void paneUusMuna(){
		int nr=(rnd.nextInt()>>>1)%4+1;
		int kiirus=(rnd.nextInt()>>>1)%3+1;
		switch(nr){
			case 1:	m.addElement(new Muna(0,korgus/5-munaSuurus+3, kiirus));
				break;
			case 2:	m.addElement(new Muna(0,korgus/2-munaSuurus+3, kiirus));
				break;
			case 3: m.addElement(new Muna(laius,korgus/5-munaSuurus-3,kiirus));
				break;
			case 4: m.addElement(new Muna(laius,korgus/2-munaSuurus-3, kiirus));
				break;
		}
	}

	void reset(){
		korgus=getHeight();
		laius=getWidth();
		punktid=0;
		elud=5;
		ax=ay=true;
		pikkus=laius/4;
	}

	public void liiguta(){
		Muna tmp;
		for(int i=0; i<m.size(); i++){
		  tmp=(Muna)m.elementAt(i);
		  
		  if (tmp.x<pikkus+2){ 			                     // Muna on vasakul rajal!
			tmp.x+=tmp.kiirusRajal*xySuhe;
			tmp.y+=tmp.kiirusRajal;
		  }else if (tmp.x>laius-pikkus-munaSuurus-2){        // Muna on paremal rajal!
			tmp.x-=tmp.kiirusRajal*xySuhe;
			tmp.y+=tmp.kiirusRajal;
		  } else {
			tmp.y+=kiirusOhus;                               // Muna on hus!
		  }
		  
		  if (tmp.y+munaSuurus/2>y && tmp.y-munaSuurus/2<y){ // Kas muna on korvis?
			if (tmp.x>x && tmp.x+munaSuurus<x+pikkus){
				punktid+=punktidYheMunaEest;
				m.removeElementAt(i);
				paneUusMuna();

				if(punktid/punktidYheMunaEest==10){
					paneUusMuna();
				}
			}
		  } 

		  if (tmp.y>korgus+munaSuurus){						 // Kas muna on ekraanist vljas?
			 m.removeElementAt(i);
			 paneUusMuna();
			 elud--;
			 if (elud<=0){
				Munapyydja.kuvaEkraan(new Lopp(punktid));
			 }
		  }
		}
		repaint();
	}
	
	public void showNotify(){
		reset();
		paneUusMuna();
		t=new Timer();
		TimerTask tt=new TimerTask(){
			public void run(){
				liiguta();
			}
		};
		t.schedule(tt,50,50);
	}

	public void hideNotify(){
		t.cancel();
	}
}

