import javax.microedition.rms.*;
import java.io.*;
import java.util.*;

public class Database{
	private static final String recordName="skoorid";
	RecordStore rs;
        RecordEnumeration re;

	public void open() throws Exception{
     	rs=RecordStore.openRecordStore(recordName, true, RecordStore.AUTHMODE_PRIVATE, true);  
     	re=rs.enumerateRecords(null, null, true);	
	}

	public void close() throws Exception{
      		 rs.closeRecordStore();
			 re.destroy();         
	}
	
	public Skoor maxSkoor() throws Exception{
		Skoor max=new Skoor();
		Skoor tmp=new Skoor();
		re.reset();
		while(re.hasNextElement()){
			tmp.fromByteArray(re.nextRecord());
			if (tmp.punktid>max.punktid){
				max.punktid=tmp.punktid;
				max.nimi=tmp.nimi;
			}
		}
		return max;
	}

	public void saveSkoor(Skoor data) throws Exception{
		byte[] bArray=data.toByteArray();
        rs.addRecord(bArray, 0, bArray.length);
	}
	
	public String[] listSkoor() throws Exception{
		re.reset();
		String[] result=new String[re.numRecords()];
		Skoor tmp=new Skoor();

		int index=0;
		while(re.hasNextElement()){
			tmp.fromByteArray(re.nextRecord());
			result[index++]=String.valueOf(tmp.punktid)+" "+tmp.nimi;
		}

		return result;
	}
	
	public static void clear() throws Exception{
		RecordStore.deleteRecordStore(recordName);
	}
}