import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import java.io.*;

public class Net extends Form implements CommandListener{
	Command ei=new Command("Tagasi", Command.EXIT, 1);
	Command jah=new Command("Saada", Command.SCREEN, 2);
	TextField aadress=new TextField("Aadress: ", "http://localhost:8080/m2rt/servlet/mobiil", 100, TextField.URL);
	StringItem olukord=new StringItem("", "");
	Skoor parim;
	String netiTeade;

	public Net(){
		super("Saadan netti?");
		try{
			Database baas=new Database();
			baas.open();
			parim=baas.maxSkoor();
			baas.close();
			if (parim==null || parim.punktid==0){
				throw new Exception();
			}
			netiTeade=parim.nimi+" on saavutanud mngus \"munapdja\" tulemuse "+String.valueOf(parim.punktid)+" punkti!";
			append(new StringItem("Kas saadan jrgneva info netti? ", netiTeade));
			append(aadress);
			append(olukord);
			addCommand(jah);
		}catch(Exception e){
			append(new StringItem("Viga: ", "Tulemused puuduvad! Ei saa midagi saata."));
		}
		addCommand(ei);
		setCommandListener(this);
	}
	
   public void commandAction(Command command, Displayable displayable) {
		if (command==ei){
			Munapyydja.kuvaEkraan(new Menyy());
		}

		if (command==jah){
			String sisu;
			Saatja saatja=new Saatja();
			saatja.start();

		}
   }
	String teeUrliks(String tekst){
		StringBuffer sb=new StringBuffer(tekst.length());
		for(int i=0; i<tekst.length(); i++){
			char c=tekst.charAt(i);
			if(c=' '){
				sb.append("%20");
			}else{
			 sb.append(c);
			}
		}
		return sb.toString();
	}

    class Saatja extends Thread{
	public void run(){
		String url=teeUrliks(aadress.getString()+"?author=munapyydja&contents="+netiTeade);
       
		HttpConnection hcon = null;
        DataInputStream dis = null;
        StringBuffer responseMessage = new StringBuffer();
        try{
            hcon = (HttpConnection)Connector.open(url);
            dis = new DataInputStream(hcon.openInputStream());          
            int ch;
            while ((ch=dis.read())!=-1) {
                responseMessage.append((char)ch);
            }
        }catch(Exception e){
            e.printStackTrace();
            responseMessage.append("ERROR");
        }finally{
            try{
                if (hcon != null) hcon.close();
                if (dis != null) dis.close();
            }catch (IOException ioe){
                ioe.printStackTrace();
            }
        }
		if (responseMessage.toString().equals("ok")){
 			removeCommand(jah);
			olukord.setText("Saadetud!");
		}else{
			olukord.setText("Ei suutnud saata!");
		}		
    }
}


}